__kernel void fun(__global float *arrIn, const int length) {
   int index = get_global_id(0);
   if (index < length) {
      int i;
      for (i = 0; i < 1000; i++) {
         arrIn[index] = sin(arrIn[index]) * cos(arrIn[index]) + arrIn[index];
         arrIn[index] *= 0.04924f;
         arrIn[index] = sqrt(arrIn[index]);
      }
   }
}

__kernel void fun2(__global float *arrIn, __global float *results, const int length) {
   int index = get_global_id(0);

   if (index < length) {

      int i;
      for(i = 0; i < 1000; i++) {
         arrIn[index] = arrIn[index] * sin(results[index]) * 
               results[index];
         if (i + index < length) {
            arrIn[index] += arrIn[i + index] * cos(1.0f - sin(results[i + index]));
         }
         results[i] = 0.563f * sqrt(arrIn[i]) + cos(results[i]);
      }
   }

}
